<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>UserDetail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class="container jumbotron w-50">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3>Chi tiết User</h3>
                <a id="inp-id"></a>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Name</label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">User Name</label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-username" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Email</label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-email" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Address</label>
            </div>
            <div class="col-sm-9">
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="suite">Suite</label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" id="inp-suite">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="street">Street</label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" id="inp-street">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="city">City</label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" id="inp-city">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="zipcode">ZipCode</label>
                    </div>
                    <div class="col-sm-10">
                        <input type="text" class="form-control" id="inp-zipcode">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-2">
                        <label for="geo">Geo</label>
                    </div>
                    <div class="col-sm-10">
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lat">Lat</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" id="inp-lat" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-2">
                                <label for="lng">lng</label>
                            </div>
                            <div class="col-sm-10">
                                <input type="text" id="inp-lng" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Phone</label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-phone" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <label for="">Website</label>
            </div>
            <div class="col-sm-9">
                <input type="text" id="inp-website" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12" style="text-align: right;">
                <button id="btn-quaylai" class="btn btn-success w-25">QUAY LẠI</button>
                <button id="btn-update" class="btn btn-success w-25">UPDATE</button>
            </div>
        </div>
    </div>
</body>
<script>
    //REGION 1

    //REGION 2
    $(document).ready(function(){
        onPageLoading();
        //gán sự kiện cho nút update
        $("#btn-update").on("click", onBtnUpdateClick);
        //gán sự kiện cho nút quay lại
        $("#btn-quaylai").on("click", function(){
            window.history.back();
        })
    })
    //REGION 3
    //hàm thục hiện load trang
    function onPageLoading(){
        console.log("Laoding");
        //thu thập dữ liệu
        var vIdObj = {id: ""};
        getDataId(vIdObj);
        console.log(vIdObj);
        //kiểm tra dữ liệu
        var vIsCheck = validataId(vIdObj)
        if(vIsCheck){
            //gọi api
            callApiGetUserById(vIdObj);
        }
    }
    //hàm thục hiện sự kiẹn nút update click
    function onBtnUpdateClick(){
        console.log("nút update được ấn");
        //b1 thu thập dữ liệu
        var vUserObj = {
            id: "",
            name: "",
            username: "",
            email:"",
            address: {
                street: "",
                suite: "",
                city: "",
                zipcode: "",
                geo: {
                    lat: "",
                    lng: ""
                }
            },
            phone: "",
            website: "",
            company:{
                name: "",
                catchPhrase: "",
                bs: ""
            }
        }
        getDataUserObj(vUserObj);
        //b2 kiểm tra dữ liệu
        var vIsCheck = validataUserObj(vUserObj)
        if(vIsCheck){
            //b3 gọi api
            callApiUpdateUserById(vUserObj);
            //b4 hiển thị thông tin
        }
    }
    //REGION 4
    //hàm thu thập dữ liệu UserObj
    function getDataUserObj(paramUsers){
        var vQueryString = window.location.href;
        var vNewUrl = new URL(vQueryString);
        var vSearchParams = new URLSearchParams(vNewUrl.search);
        var vId = vSearchParams.get("id");
        paramUsers.id = vId;
        paramUsers.name = $("#inp-name").val().trim();
        paramUsers.username = $("#inp-username").val().trim();
        paramUsers.email = $("#inp-email").val().trim();
        paramUsers.address.suite = $("#inp-suite").val().trim();
        paramUsers.address.street = $("#inp-street").val().trim();
        paramUsers.address.city = $("#inp-city").val().trim();
        paramUsers.address.zipcode = $("#inp-zipcode").val().trim();
        paramUsers.address.geo.lat = $("#inp-lat").val().trim();
        paramUsers.address.geo.lng = $("#inp-lng").val().trim();
        paramUsers.phone = $("#inp-phone").val().trim();
        paramUsers.website = $("#inp-website").val().trim();
    }
    //hàm kiểm tra dữ liệu user obj
    function validataUserObj(paramUser){
        if(paramUser.name == ""){
            alert("Bạn chưa nhập name");
            $("#inp-name").focus()
            return false;
        }
        if(paramUser.username == ""){
            alert("Bạn chưa nhập username");
            $("#inp-username").focus()
            return false;
        }
        if(paramUser.email == ""){
            alert("Bạn chưa nhập email");
            $("#inp-email").focus()
            return false;
        }
        if(paramUser.address.suite == ""){
            alert("Bạn chưa nhập suite");
            $("#inp-suite").focus()
            return false;
        }
        if(paramUser.address.street == ""){
            alert("Bạn chưa nhập street");
            $("#inp-street").focus()
            return false;
        }
        if(paramUser.address.city == ""){
            alert("Bạn chưa nhập city");
            $("#inp-city").focus()
            return false;
        }
        if(paramUser.address.zipcode == ""){
            alert("Bạn chưa nhập zipcode");
            $("#inp-zipcode").focus()
            return false;
        }
        if(paramUser.address.geo.lat == ""){
            alert("Bạn chưa nhập lat");
            $("#inp-lat").focus()
            return false;
        }
        if(paramUser.address.geo.lng == ""){
            alert("Bạn chưa nhập lng");
            $("#inp-lng").focus()
            return false;
        }
        if(paramUser.phone == ""){
            alert("Bạn chưa nhập phone");
            $("#inp-phone").focus()
            return false;
        }
        if(paramUser.website == ""){
            alert("Bạn chưa nhập website");
            $("#inp-website").focus()
            return false;
        }
        return true;
    }
    // hàm gọi api để update user by id
    function callApiUpdateUserById(paramUser){
        const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";
        $.ajax({
            url: vBASE_URL + paramUser.id,
            type: "PUT",
            contentType: "application/json;charset=UTF-8",
            dataType: "json",
            data: JSON.stringify(paramUser),
            success: function(response){
                console.log("Cập nhật thông tin user thành công");
                window.location.href = "Task 35.10 Load all users.html"
            },
            error: function(ajaxContext){
                console.log(ajaxContext)
            }
        })
    }
    //hàm thu thập dữ liệu id
    function getDataId(paramId){
        var vQueryString = window.location.href;
        var vNewUrl = new URL(vQueryString);
        var searchParams = new URLSearchParams(vNewUrl.search);
        var vId = searchParams.get("id");
        paramId.id = vId;
    }
    //hàm kiểm tra dữ liệu
    function validataId(paramId){
        if(paramId.id == ""){
            alert("Id không tồn tại");
            return false;
        }
        if(isNaN(paramId.id)){
            alert("Id phải là số nguyên dương");
            return false;
        }
        return true;
    }
    //hàm gọi api để lấy thông tin người bằng id
    function callApiGetUserById(paramId){
        const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";
        $.ajax({
            url: vBASE_URL + "/" + paramId.id,
            type: "GET",
            dataType: "json",
            success: function(response){
                console.log(response)
                console.log(JSON.stringify(response));
                //hiển thị thông tin người dùng lên form
                showDataToFormUsers(response);
            },
            error: function(ajaxContext){
                console.log(ajaxContext);
            }
        })
    }
    //hàm hiển thị thông tin người dùng lên form
    function showDataToFormUsers(paramResponse){
        $("#inp-name").val(paramResponse.name);
        $("#inp-username").val(paramResponse.username);
        $("#inp-email").val(paramResponse.email);
        $("#inp-suite").val(paramResponse.address.suite);
        $("#inp-street").val(paramResponse.address.street);
        $("#inp-city").val(paramResponse.address.city);
        $("#inp-zipcode").val(paramResponse.address.zipcode);
        $("#inp-lat").val(paramResponse.address.geo.lat);
        $("#inp-lng").val(paramResponse.address.geo.lng);
        $("#inp-phone").val(paramResponse.phone);
        $("#inp-website").val(paramResponse.website);
    }
</script>
</html>